# 170806 finland map generation

setwd("~/Documents/UNI_und_VORLESUNGEN/11 phd projects/1 Meta HAPLOTYPING/2 JAMP finland/r maps")

library("RColorBrewer")
library("png")
library("pegas")




files <- "_haplomaps/170824_BF2+BR2_haplotable_alpha_5_haplosize_0.01_minOTU_0.01.csv"
keep <- 4:21
#keep <- 22:39



plot_me <- function(files, keep){
keep_ID <- keep
table <- read.csv(files, stringsAsFactors=F)

if(keep[1]=="A"){keep <- 4:21} else {
keep_ID <- paste("+", range(keep)[1], "_", range(keep)[2], collapse="", sep="")
data <- table[keep]
table[4:21] <- table[keep]
keep <- 4:21

}

data <- table[keep] # remove replicates




cbind(names(data))

otus <- unique(table$OTU)


if(T){
# calculate %tage
# keep 1%+ OTUs

for(i in 1:ncol(data)){

for(k in 1:length(otus)){
select <- which(table$OTU== otus[k])
temp <- data[select, i]/sum(data[select, i])*100
temp[is.na(temp)] <- 0  # replace if NA because 0
temp[temp<5] <- 0
data[select, i] <- temp
}
}

table <- table[rowSums(data)>0,]
data <- data[rowSums(data)>0,]
#otus <- unique(table$OTU)
#head(table)
#head(data)
}

folder_name <- sub("_haplomaps/", "_plots/", files)
folder_name <- sub(".csv", "", folder_name)

folder_name <- paste(folder_name, "_", keep_ID, "/", sep="")

dir.create(folder_name)


#### make haplotype networks
#install.packages("pegas")
#library("pegas")
i<-4

for (i in 1:length(otus)){

temp <- table[table$OTU==otus[i],]

if(nrow(temp)>2){
x <- as.list(temp$sequ)
names(x) <- temp$Haplotypes

x <- as.DNAbin(as.alignment(x))
h <- haplotype(x, labels=temp$Haplotypes)
net <- haploNet(h)

net[,3] <- net[,3] #-1
#print.default(net)

#mysize <- rowSums(temp[5:24], na.rm=T)/sum(temp[5:24], na.rm=T)*100
mysize <- rowSums(temp[5:22]>0, na.rm=T)

pdf(paste(folder_name, otus[i], "_net.pdf", sep=""), width=8, height=8)

plot(net, size= mysize/3, scale.ratio = 1, cex = 1)


dev.off()
}
}

##### haplotype networks end
#library(RColorBrewer)
#library(png)
#install.packages("png")

map <- read.csv("Tab_gps.csv", stringsAsFactors=F)

i <- 1

for (i in 1:length(otus)){


temp <- data[table$OTU==otus[i],]
temp[is.na(temp)] <- 0

ima <- readPNG("map_finland.png")

pdf(paste(folder_name, "_", otus[i], "map.pdf", sep=""), width=12, height=13)

par(oma=c(0,0,0,0), mar=c(0,0,0,0))
plot(-1,-1, ylim=c(0,4), xlim=c(0, 2))

rasterImage(ima, xleft= -0.05, ybottom= -0.1, xright= 2.05, ytop= 4.1)
#points(map$S, map$N)
#text(map$S+0.001, map$N, map$No)

my_palette <- brewer.pal(nrow(temp),"Set1")

#k <- 6
#map$hori[k] <- 0.36
#map$vert[k] <- 0.75

for(k in c(keep-3)){
if(sum(temp[,k])>0){
par(new=T, fig=c(map$hori[k], map$hori[k]+0.08, map$vert[k], map$vert[k]+0.08), oma=c(0,0,0,0), mar=c(0,0,0,0))
pie(temp[,k], col= my_palette, labels=NA)
}
}

dev.off()


# PNG start

dir.create(paste(folder_name, "__PNG", sep=""))

png(paste(folder_name, "__PNG/", otus[i], "_map.png", sep=""), width=1200/2, height=1300/2)

par(oma=c(0,0,0,0), mar=c(0,0,0,0))
plot(-1,-1, ylim=c(0,4), xlim=c(0, 2))

rasterImage(ima, xleft= -0.05, ybottom= -0.1, xright= 2.05, ytop= 4.1)
#points(map$S, map$N)
#text(map$S+0.001, map$N, map$No)

my_palette <- brewer.pal(nrow(temp),"Set1")

#k <- 6
#map$hori[k] <- 0.36
#map$vert[k] <- 0.75

for(k in c(keep-3)){
if(sum(temp[,k])>0){
par(new=T, fig=c(map$hori[k], map$hori[k]+0.08, map$vert[k], map$vert[k]+0.08), oma=c(0,0,0,0), mar=c(0,0,0,0))
pie(temp[,k], col= my_palette, labels=NA)
}
}

dev.off()
# PNG ENDE

}

} #function end















glumanda <- read.csv("_haplomaps/haplotable_0.01_217_alpha_5.csv", stringsAsFactors=F)
reorder <- order(as.numeric(sub(".*_(.*)_.*_.*_.*", "\\1", names(glumanda)[4:147])))+3
glumanda <- glumanda[, c(1:3, reorder, 148)]

cbind(names(glumanda))

write.csv(glumanda, "_haplomaps/haplotable_0.01_217_alpha_5_reordered.csv", row.names=F)



#plot_me("_haplomaps/haplotable_0.01_217_alpha_5_reordered.csv", c(4:21))

for(k in c(0,2,4,6)){
plot_me("_haplomaps/haplotable_0.01_217_alpha_5_reordered_SUB.csv", c((4+18*k):(21+18*k)))
}

for(k in c(1,3,5,7)){
plot_me("_haplomaps/haplotable_0.01_217_alpha_5_reordered_SUB.csv", c((4+18*k):(21+18*k)))
}


num <- list.files("_plots/haplotable_0.01_217_alpha_5_reordered_SUB_+4_21/__PNG")
num <- as.numeric(sub("OTU_(.*)_map.png","\\1", num))

folder <- c("haplotable_0.01_217_alpha_5_reordered_SUB_+4_21", "haplotable_0.01_217_alpha_5_reordered_SUB_+40_57", "haplotable_0.01_217_alpha_5_reordered_SUB_+76_93", "haplotable_0.01_217_alpha_5_reordered_SUB_+112_129")

pair <- c("BF1+BR1", "BF2+BR2", "BF1+BR2", "BF2+BR1")

# combine all 4 plots into one figure!
i <- 1
k <- 1

for(k in 1:length(num)){
pdf(paste("_plots/combo_217bp/OTU_", num[k], "_map_217bp.pdf", sep=""), height=8, width=26)
par(mfrow=c(1,4), oma=c(0,0,0,0), mar=c(0,0,0,0))

for(i in 1:4){
plot(-1,-1, ylim=c(0,4), xlim=c(0, 2), xaxt="n", yaxt="n")
rasterImage(readPNG(paste("_plots/", folder[i], "/__PNG/OTU_", num[k], "_map.png", sep="")), xleft= -0.05, ybottom= -0.1, xright= 2.05, ytop= 4.1)

text(0, 4, pair[i], adj=0, cex=2.5 )

}
dev.off()
}




plot_me("_haplomaps/haplotable_0.01_BF1+BR1_alpha_5.csv", "A")
plot_me("_haplomaps/haplotable_0.01_BF1+BR1_alpha_5.csv", 22:39)
plot_me("_haplomaps/haplotable_0.01_BF2_BR2_alpha_5.csv", "A")
plot_me("_haplomaps/haplotable_0.01_BF2_BR2_alpha_5.csv", 22:39)
plot_me("_haplomaps/haplotable_0.01_BF1_BR2_alpha_5.csv", "A")
plot_me("_haplomaps/haplotable_0.01_BF1_BR2_alpha_5.csv", 22:39)



#keep <- 22:39

plot_me("_haplomaps/170825_BF1+BR1/170825_BF1+BR1_haplotable_alpha_5_haplosize_0.01_minOTU_0.1.csv", "A")
plot_me("_haplomaps/170825_BF1+BR1/170825_BF1+BR1_haplotable_alpha_5_haplosize_0.01_minOTU_0.1.csv", 22:39)

plot_me("_haplomaps/170825_BF1+BR2/170825_BF1+BR2_haplotable_alpha_5_haplosize_0.01_minOTU_0.1.csv", "A")
plot_me("_haplomaps/170825_BF1+BR2/170825_BF1+BR2_haplotable_alpha_5_haplosize_0.01_minOTU_0.1.csv", 22:39)

plot_me("_haplomaps/170825_BF2+BR1/170825_BF2+BR1_haplotable_alpha_5_haplosize_0.01_minOTU_0.1.csv", "A")
plot_me("_haplomaps/170825_BF2+BR1/170825_BF2+BR1_haplotable_alpha_5_haplosize_0.01_minOTU_0.1.csv", 22:39)

plot_me("_haplomaps/170825_BF2+BR2/170825_BF2+BR2_haplotable_alpha_5_haplosize_0.01_minOTU_0.1.csv", "A")
plot_me("_haplomaps/170825_BF2+BR2/170825_BF2+BR2_haplotable_alpha_5_haplosize_0.01_minOTU_0.1.csv", 22:39)


# get taxonomy
library("JAMP")
setwd("~/Documents/UNI_und_VORLESUNGEN/11 phd projects/1 Meta HAPLOTYPING/2 JAMP finland/r maps/_haplomaps/170825_BF2+BR2")
Bold_web_hack("_BOLD_170825_BF2+BR2.txt")


setwd("~/Documents/UNI_und_VORLESUNGEN/11 phd projects/1 Meta HAPLOTYPING/2 JAMP finland/r maps/_haplomaps/170825_BF1+BR1")
Bold_web_hack("_BOLD_170826_BF1+BR1.txt")


setwd("~/Documents/UNI_und_VORLESUNGEN/11 phd projects/1 Meta HAPLOTYPING/2 JAMP finland/r maps/_haplomaps/170825_BF2+BR1")
Bold_web_hack("_BOLD_170826_BF2+BR1.txt")


setwd("~/Documents/UNI_und_VORLESUNGEN/11 phd projects/1 Meta HAPLOTYPING/2 JAMP finland/r maps/_haplomaps/170825_BF1+BR2")
Bold_web_hack("_BOLD_170826_BF1+BR2.txt")




